#define DLL_EXPORT

#ifndef _DLL_TUTORIAL_H_
    #define _DLL_TUTORIAL_H_
    #include <iostream>

    #if defined DLL_EXPORT
      #define DECLDIR __declspec(dllexport)
    #else
      #define DECLDIR __declspec(dllimport)
    #endif


  struct HwId
  {
    CString VendorID;
    CString ProductID;
    bool    IdSet;
    HwId()  { IdSet = false; VendorID.Empty(); ProductID.Empty(); }
  };

  struct PortDetails
  {
    CString PortName;
    CString DevDesc;
    HwId    HardwareID;
    PortDetails() { PortName.Empty(); DevDesc.Empty(); }
  };
  typedef CArray<PortDetails> PortList;

  PortList  m_ComsPorts;


    extern "C"
    {

		DECLDIR unsigned char MA_ReadDigitalInput( unsigned char Port , unsigned char Channel );
		DECLDIR unsigned char MA_ReadInputs( unsigned char Port );
		DECLDIR unsigned int MA_ReadAnalogInput( unsigned char Port , unsigned char Channel );
		DECLDIR void MA_WriteRelay( unsigned char Port , unsigned char Channel , unsigned char Value );
		DECLDIR void MA_WriteRelays( unsigned char Port , unsigned char Value );
		DECLDIR void MA_WriteTran( unsigned char Port , unsigned char Channel , unsigned char Value );
		DECLDIR void MA_WriteTrans( unsigned char Port , unsigned char Value );
		DECLDIR void MA_PWMEnable( unsigned char Port , unsigned char Value );
		DECLDIR void MA_PWMDuty( unsigned char Port , unsigned char Channel , unsigned int Value );
		DECLDIR void MA_PWMConfig( unsigned char Port , unsigned char Channel , unsigned int Period, unsigned char Scaler );
		DECLDIR unsigned char MA_ReadKey( unsigned char Port );
		DECLDIR unsigned char MA_ReadRTC( unsigned char Port , unsigned char Unit );
		DECLDIR void MA_WriteRTC( unsigned char Port , unsigned char Unit, unsigned char Value );
		DECLDIR void MA_LCDClear( unsigned char Port );
		DECLDIR void MA_LCDCursor( unsigned char Port , unsigned char X , unsigned char Y );
		DECLDIR void MA_LCDPrint( unsigned char Port, unsigned char * text);
		DECLDIR void MA_LCDNumber( unsigned char Port , unsigned int Value );
		DECLDIR void MA_LCDPixel( unsigned char Port , unsigned char X , unsigned char Y , unsigned char State );
		DECLDIR void MA_LCDLine( unsigned char Port , unsigned char X1 , unsigned char Y1 , unsigned char X2 , unsigned char Y2 );
		DECLDIR void MA_LCDRect( unsigned char Port , unsigned char X1 , unsigned char Y1 , unsigned char X2 , unsigned char Y2 );
		DECLDIR void MA_LCDBitmap( unsigned char Port, unsigned char X , unsigned char Y , unsigned char * text);
		DECLDIR void MA_LCDBacklight( unsigned char Port , unsigned char Value );
		DECLDIR void MA_LCDOptions( unsigned char Port , unsigned char Foreground , unsigned char Background , unsigned char Transparent );
		DECLDIR unsigned char MA_CardInserted( unsigned char Port );
		DECLDIR unsigned char MA_CardOpen( unsigned char Port , unsigned char * filename );
		DECLDIR unsigned char MA_CardReadByte( unsigned char Port );
		DECLDIR unsigned char MA_CardWriteByte( unsigned char Port, unsigned char Data );
		DECLDIR unsigned char MA_CardCreate( unsigned char Port , unsigned char * filename );
		DECLDIR unsigned char MA_CardDelete( unsigned char Port , unsigned char * filename );
		DECLDIR unsigned char MA_CommsRead( unsigned char Port , unsigned char Timeout );
		DECLDIR void MA_CommsWrite( unsigned char Port, unsigned char Data );
		DECLDIR void MA_CommsBaud( unsigned char Port, unsigned char Baud );
		DECLDIR unsigned char MA_GetAPIVersion( unsigned char Port );
		DECLDIR void MA_LCDVerbose( unsigned char Port, unsigned char Value );

	    DECLDIR unsigned char MA_ComFindFirst( void );
	    DECLDIR unsigned char MA_ComQuery( unsigned char Port );
	    DECLDIR unsigned char MA_ComOpen( unsigned char Port );
	    DECLDIR unsigned char MA_ComClose( unsigned char Port );
	    
        DECLDIR unsigned char MA_IPOpen( unsigned char Channel, unsigned char IP0 , unsigned char IP1 , unsigned char IP2 , unsigned char IP3 );
	    DECLDIR void MA_IPClose( unsigned char Channel );

	    DECLDIR void BaudRateSet( unsigned char Port, unsigned long Baud );
	    DECLDIR unsigned int ReadCharCOM( unsigned char Port, unsigned int timeout, unsigned int timeout_val );
	    DECLDIR void SendCharCOM( unsigned char Port, unsigned char Data );
	    DECLDIR void SetDTRStatePrivate( unsigned char Port, unsigned char state );
	    DECLDIR void SetFlowControlPrivate( unsigned char Port, unsigned char state );
    }

 #endif

